"""
cssutils - CSS Cascading Style Sheets library for Python

    Copyright (C) 2004-2005 Christof Hoeke

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

A Python package to parse and build CSS Cascading Style Sheets. Partly
implements the DOM Level 2 Stylesheets  and DOM Level 2 CSS interfaces.

Uses xml.dom.DOMException and subclasses so may need PyXML.
Tested with Python 2.4.1 on Windows XP with PyXML 0.8.4 installed.

Please visit http://cthedot.de/cssutils/ for full details and updates.
"""
__docformat__ = 'restructuredtext'

__version__ = '0.8a5'


# only internal use!
import _loghandler
_log = _loghandler.ErrorHandler()

from _parser import _getParser

# main CSSParser
from cssparser import CSSParser

# import packages
import cssutils.css as css
import cssutils.stylesheets as stylesheets


if __name__ == '__main__':
    print dir()