"""
Document Object Model Level 2 CSS
http://www.w3.org/TR/2000/PR-DOM-Level-2-Style-20000927/css.html

currently implemented
    - CSSStyleSheet
    - CSSRuleList
    - CSSRule
    - CSSCharsetRule
    - CSSImportRule
    - CSSStyleRule
    - CSSStyleDeclaration
    - CSSUnknownRule
    - CSSValue (incomplete)

    - Comment (cssutils addon)

todo
    - CSSMediaRule
    - CSSPageRule
    - value classes
"""
__docformat__ = 'restructuredtext'

__all__ = [
    'Comment',
    'CSSStyleSheet',
    'CSSRuleList',
    'CSSRule',
    'CSSCharsetRule',
    'CSSImportRule',
##    'CSSMediaRule',
    'CSSStyleRule',
    'CSSStyleDeclaration',
    'CSSUnknownRule',
    'CSSValue'
    ]
__version__ = '0.8a3'

from comment import Comment

from cssrulelist import CSSRuleList
from cssrule import CSSRule

from cssvalue import CSSValue
from cssstyledeclaration import CSSStyleDeclaration

from cssstylerule import CSSStyleRule

from csscharsetrule import CSSCharsetRule
from cssimportrule import CSSImportRule
## from cssmediarule import CSSMediaRule
from cssunknownrule import CSSUnknownRule

# needs to be last!
from cssstylesheet import CSSStyleSheet


if __name__ == '__main__':
    print dir()
    print 'CSSStyleSheet', CSSStyleSheet()
    print 'CSSRuleList', CSSRuleList()
    print 'CSSRule', CSSRule()
    print 'CSSValue', CSSValue()
    print 'CSSStyleDeclaration', CSSStyleDeclaration()
    print 'CSSStyleRule', CSSStyleRule()
    print 'CSSCharsetRule', CSSCharsetRule()
    print 'CSSStyleSheet', CSSStyleSheet()

    