"""
contains DOM Level 2 CSSMediaRule implementation.

TODO
    insertRule: HIERARCHY_REQUEST_ERR
    cssText: fset
"""
__docformat__ = 'restructuredtext'
##
##__all__ = ['CSSMediaRule']
##__version__ = '0.8'
##
##
##import xml.dom
##
##import cssrule
##import cssrulelist
##import cssstylerule
##
##import cssutils.cssparser
##
##from cssutils import stylesheets
##
##
##
##class CSSMediaRule(cssrule.CSSRule):
##    """
##    represents a @media rule in a CSS style sheet. A @media rule can be
##    used to delimit style rules for specific media types.  
##    """
##    
##    # CONSTANT
##    type = cssrule.CSSRule.MEDIA_RULE 
##
##
##    def __init__(self, mediaText=u'', readonly=False, startline=1):
##        """
##        :mediaText: list of mediatypes as a string
##        :readonly: ...
##        :startline: of this rule
##        """
##        self._startline = startline
##        self._readonly = False
##
##        self._media = stylesheets.MediaList(
##            mediaText, readonly=readonly, startline=startline)
##        self._rules = cssrulelist.CSSRuleList()
##
##        self._readonly = readonly
##
##
##    def _getMedia(self):
##        "returns MediaList"
##        return self._media
##    
##    media = property(_getMedia,
##        doc=u"(DOM readonly) A list of media types for this rule of type\
##            MediaList")
##
##    
##    def _getCssRules(self):
##        return self._rules
##
##    def _setCssRules(self, rules):
##        self._rules = rules
##
##    cssRules = property(_getCssRules, _setCssRules,
##        doc="(DOM readonly) A list of all CSS rules contained within the\
##            media block.")
##
##
##    def deleteRule(self, index):
##        """
##        Used to delete a rule from the media block.
##        
##        :index: within the media block's rule collection of the rule to
##            remove.
##
##        DOMException
##        - INDEX_SIZE_ERR: (self)
##            Raised if the specified index does not correspond to a rule in
##            the media rule list.
##        - NO_MODIFICATION_ALLOWED_ERR: (self)
##            Raised if this media rule is readonly.            
##        """        
##        self._checkReadonly()
##        
##        try:
##            del self._rules[index]
##        except IndexError:
##            raise xml.dom.IndexSizeErr(
##                u'Index %s not in the RuleList with a len of %s' % (
##                    index, len(self._rules)))
##
##
##    def insertRule(self, rule, index):
##        """
##        Used to insert a new rule into the media block.
##        
##        :rule: The parsable text representing the rule. For rule sets this
##            contains both the selector and the style declaration. For
##            at-rules, this specifies both the at-identifier and the rule
##            content.
##            
##            cssutils also allows rule to be a **CSSRule** object
##            
##        :index: within the media block's rule collection of the rule before
##            which to insert the specified rule. If the specified index is
##            equal to the length of the media blocks's rule collection, the
##            rule will be added to the end of the media block.
##
##        DOMException on setting        
##        - HIERARCHY_REQUEST_ERR:
##            Raised if the rule cannot be inserted at the specified index,
##            e.g., if an @import rule is inserted after a standard rule set
##            or other at-rule.
##        - INDEX_SIZE_ERR: (self)
##            Raised if the specified index is not a valid insertion point.
##        - NO_MODIFICATION_ALLOWED_ERR: (self)
##            Raised if this media rule is readonly.
##        - SYNTAX_ERR:
##            Raised if the specified rule has a syntax error and is
##            unparsable.
##
##        returns the index within the media block's rule collection of the
##        newly inserted rule.
##
##        """
##        self._checkReadonly()
##
##        if index > len(self._rules):
##            raise xml.dom.IndexSizeErr(
##                u'Index %s higher than current listlength of %s.' % (
##                    index, len(self._rules)))
##        
##        # cssutils only
##        if type(rule) == cssstylerule.CSSStyleRule:
##            r = rule.cssText
##
####        TODO: parse
##        
####        self._rules.insert(index, rule)
##        return index
##
##
##    def addRule(self, rule):
##        """
##        (cssutils)
##        append new CSSRule to this at-media block.
##        """
##        self.insertRule(rule, len(self._rules))
##
##
##    def getFormatted(self, indent=4):
##        if not self._rules:
##            return u''
##        indentspace = indent * ' '
##        out = []
##        out.append(u'@media %s {' % (self._media.getFormatted()))
##        for rule in self._rules:
##            out.append(rule.getFormatted(indent, indent))
##        out.append(u'}')
##        return u'\n'.join(out)
##
##    def _setCssText(self, cssText, parser=None):
##        """
##        DOMException on setting
##         
##        - SYNTAX_ERR: (lexer)
##            Raised if the specified CSS string value has a syntax error and
##            is unparsable.
##        - INVALID_MODIFICATION_ERR: (L)
##            Raised if the specified CSS string value represents a different
##            type of rule than the current one.
##        - HIERARCHY_REQUEST_ERR: (parser)
##            Raised if the rule cannot be inserted at this point in the
##            style sheet.
##        - NO_MODIFICATION_ALLOWED_ERR: (super)
##            Raised if the rule is readonly.
##        """
##        super(CSSMediaRule, self)._setCssText(cssText)
##
##        if parser is None:
##            parser = cssutils.cssparser.getCSSParser()
##        mediaText, rulesText =\
##            parser.parseCSSMediaRule(cssText, line=self._startline)
##
##        self._media = stylesheets.MediaList(
##            mediaText, readonly=self._readonly, startline=self._startline)
##
##        self.cssRules = parser.parseCSSStyleSheet(
##                rulesText, line=self._startline + mediaText.count(u'\n'))
##
##
##    cssText = property(getFormatted, _setCssText,
##        doc="(DOM attribute) The parsable textual representation.")
